/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.18_02 from the
 * contents of CD.xs. Do not edit this file, edit CD.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "CD.xs"
/*
 * CD.xs - part of the Audio-Cd package.
 * Copyright (C) 1999-2002 by Doug MacEachern
 *
 * When included as part of the Standard Version of Perl or as
 * part of its complete documentation whether printed or
 * otherwise, this work may be distributed only under the terms
 * of Perl's Artistic License as included in the file COPYING.
 * Any distribution of this file or derivatives thereof outside
 * of that package requires that special arrangements be made
 * with copyright holder.
 * 
 */

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "cdaudio.h"
#include "cddb_lookup.h"

typedef struct disc_info   * Audio__CD__Info;
typedef struct track_info  * Audio__CD__Info__Track;
typedef struct disc_data   * Audio__CD__Data;
typedef struct track_data  * Audio__CD__Track;
typedef struct disc_volume * Audio__CD__Volume;
typedef struct __volume    * Audio__CD__VolumeRL;

typedef int Audio__CD;
typedef int Audio__CDDB;

#define CD_Info_present(info) info->disc_present
#define CD_Info_mode(info) info->disc_mode
#define CD_Info_current_frame(info) info->disc_current_frame
#define CD_Info_current_track(info) info->disc_current_track
#define CD_Info_first_track(info) info->disc_first_track
#define CD_Info_total_tracks(info) info->disc_total_tracks
#define CD_Info_timeval(timeval) \
SP -= items; \
XPUSHs(sv_2mortal(newSViv(timeval.minutes))); \
XPUSHs(sv_2mortal(newSViv(timeval.seconds))); \
PUTBACK; return

#define CD_Info_track_time(info) \
CD_Info_timeval(info->disc_track_time)
#define CD_Info_time(info) \
CD_Info_timeval(info->disc_time)
#define CD_Info_length(info) \
CD_Info_timeval(info->disc_length)

#define CD_Info_Track_length(tinfo)     CD_Info_timeval(tinfo->track_length)
#define CD_Info_Track_pos(tinfo)        CD_Info_timeval(tinfo->track_pos)
#define CD_Info_Track_type(tinfo)       tinfo->track_type
#define CD_Info_Track_is_audio(tinfo) \
(tinfo->track_type == CDAUDIO_TRACK_AUDIO)
#define CD_Info_Track_is_data(tinfo) \
(tinfo->track_type == CDAUDIO_TRACK_DATA)

#define CD_Data_title(data) data->data_title
#define CD_Data_artist(data) data->data_artist
#define CD_Data_extended(data) data->data_extended
#define CD_Data_genre(data) cddb_genre(data->data_genre)

#define CD_Track_name(track) track->track_name
#define CD_Track_artist(track) track->track_artist
#define CD_Track_extended(track) track->track_extended

#define CD_Volume_front(vol) &vol->vol_front
#define CD_Volume_back(vol) &vol->vol_back
#define CD_VolumeRL_right(volrl, val) \
(val >= 0 ? volrl->right = val : volrl->right)
#define CD_VolumeRL_left(volrl, val) \
(val >= 0 ? volrl->left = val : volrl->left)

static Audio__CD cd_init(SV *sv_class, char *device)
{
    int id = cd_init_device(device);
    if (id < 0) {
	return 0;
    }
    return id;
}

static SV *CD_Data_track_new(struct track_data *td)
{
    SV *sv = newSV(0);
#if 0
    struct track_data *new_td = (struct track_data *)safemalloc(sizeof(*new_td));
    Copy(td, new_td, 1, struct track_data);
#endif
    sv_setref_pv(sv, "Audio::CD::Track", (void*)td);
    return sv;
}


static SV *CD_Info_track_new(struct track_info *ti)
{
    SV *sv = newSV(0);
    sv_setref_pv(sv, "Audio::CD::Info::Track", (void*)ti);
    return sv;
}


static void boot_Audio__CD_constants(void)
{
    HV *stash = gv_stashpv("Audio::CD", TRUE);
    newCONSTSUB(stash, "PLAYING", newSViv(CDAUDIO_PLAYING));
    newCONSTSUB(stash, "PAUSED", newSViv(CDAUDIO_PAUSED));
    newCONSTSUB(stash, "COMPLETED", newSViv(CDAUDIO_COMPLETED));
    newCONSTSUB(stash, "NOSTATUS", newSViv(CDAUDIO_NOSTATUS));
    newCONSTSUB(stash, "TRACK_AUDIO", newSViv(CDAUDIO_TRACK_AUDIO));
    newCONSTSUB(stash, "TRACK_DATA", newSViv(CDAUDIO_TRACK_DATA));
}

/* XXX */
static int inexact_select_func(void)
{
    return 1;
}

#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#line 135 "CD.c"

XS(XS_Audio__CD_init); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__CD_init)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Audio::CD::init", "sv_class, device=\"/dev/cdrom\"");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SV *	sv_class = ST(0);
	char *	device;
	Audio__CD	RETVAL;

	if (items < 2)
	    device = "/dev/cdrom";
	else {
	    device = (char *)SvPV_nolen(ST(1));
	}

	RETVAL = cd_init(sv_class, device);
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Audio::CD", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Audio__CD_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__CD_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Audio::CD::DESTROY", "cd_desc");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Audio__CD	cd_desc;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    cd_desc = INT2PTR(Audio__CD,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not a reference",
			"Audio::CD::DESTROY",
			"cd_desc");
#line 137 "CD.xs"
    close(cd_desc);
#line 191 "CD.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Audio__CD_cddb); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__CD_cddb)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Audio::CD::cddb", "cd_desc");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Audio__CD	cd_desc;
	Audio__CDDB	RETVAL;

	if (sv_derived_from(ST(0), "Audio::CD")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    cd_desc = INT2PTR(Audio__CD,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Audio::CD::cddb",
			"cd_desc", "Audio::CD");
#line 144 "CD.xs"
    RETVAL = cd_desc;

#line 223 "CD.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Audio::CDDB", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Audio__CD_play); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__CD_play)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Audio::CD::play", "cd_desc, track=1");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Audio__CD	cd_desc;
	int	track;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Audio::CD")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    cd_desc = INT2PTR(Audio__CD,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Audio::CD::play",
			"cd_desc", "Audio::CD");

	if (items < 2)
	    track = 1;
	else {
	    track = (int)SvIV(ST(1));
	}

	RETVAL = cd_play(cd_desc, track);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Audio__CD_stop); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__CD_stop)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Audio::CD::stop", "cd_desc");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Audio__CD	cd_desc;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Audio::CD")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    cd_desc = INT2PTR(Audio__CD,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Audio::CD::stop",
			"cd_desc", "Audio::CD");

	RETVAL = cd_stop(cd_desc);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Audio__CD_pause); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__CD_pause)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Audio::CD::pause", "cd_desc");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Audio__CD	cd_desc;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Audio::CD")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    cd_desc = INT2PTR(Audio__CD,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Audio::CD::pause",
			"cd_desc", "Audio::CD");

	RETVAL = cd_pause(cd_desc);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Audio__CD_resume); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__CD_resume)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Audio::CD::resume", "cd_desc");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Audio__CD	cd_desc;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Audio::CD")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    cd_desc = INT2PTR(Audio__CD,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Audio::CD::resume",
			"cd_desc", "Audio::CD");

	RETVAL = cd_resume(cd_desc);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Audio__CD_eject); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__CD_eject)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Audio::CD::eject", "cd_desc");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Audio__CD	cd_desc;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Audio::CD")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    cd_desc = INT2PTR(Audio__CD,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Audio::CD::eject",
			"cd_desc", "Audio::CD");

	RETVAL = cd_eject(cd_desc);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Audio__CD_close); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__CD_close)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Audio::CD::close", "cd_desc");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Audio__CD	cd_desc;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Audio::CD")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    cd_desc = INT2PTR(Audio__CD,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Audio::CD::close",
			"cd_desc", "Audio::CD");

	RETVAL = cd_close(cd_desc);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Audio__CD_stat); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__CD_stat)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Audio::CD::stat", "cd_desc");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Audio__CD	cd_desc;
	Audio__CD__Info	RETVAL;

	if (sv_derived_from(ST(0), "Audio::CD")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    cd_desc = INT2PTR(Audio__CD,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Audio::CD::stat",
			"cd_desc", "Audio::CD");
#line 179 "CD.xs"
    RETVAL = (Audio__CD__Info)safemalloc(sizeof(*RETVAL));
    cd_stat(cd_desc, RETVAL);

#line 457 "CD.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Audio::CD::Info", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Audio__CD_play_frames); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__CD_play_frames)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Audio::CD::play_frames", "cd_desc, startframe, endframe");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Audio__CD	cd_desc;
	int	startframe = (int)SvIV(ST(1));
	int	endframe = (int)SvIV(ST(2));
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Audio::CD")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    cd_desc = INT2PTR(Audio__CD,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Audio::CD::play_frames",
			"cd_desc", "Audio::CD");

	RETVAL = cd_play_frames(cd_desc, startframe, endframe);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Audio__CD_play_track_pos); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__CD_play_track_pos)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Audio::CD::play_track_pos", "cd_desc, starttrack, endtrack, startpos");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Audio__CD	cd_desc;
	int	starttrack = (int)SvIV(ST(1));
	int	endtrack = (int)SvIV(ST(2));
	int	startpos = (int)SvIV(ST(3));
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Audio::CD")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    cd_desc = INT2PTR(Audio__CD,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Audio::CD::play_track_pos",
			"cd_desc", "Audio::CD");

	RETVAL = cd_play_track_pos(cd_desc, starttrack, endtrack, startpos);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Audio__CD_play_track); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__CD_play_track)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Audio::CD::play_track", "cd_desc, starttrack, endtrack");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Audio__CD	cd_desc;
	int	starttrack = (int)SvIV(ST(1));
	int	endtrack = (int)SvIV(ST(2));
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Audio::CD")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    cd_desc = INT2PTR(Audio__CD,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Audio::CD::play_track",
			"cd_desc", "Audio::CD");

	RETVAL = cd_play_track(cd_desc, starttrack, endtrack);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Audio__CD_play_pos); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__CD_play_pos)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Audio::CD::play_pos", "cd_desc, track, startpos");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Audio__CD	cd_desc;
	int	track = (int)SvIV(ST(1));
	int	startpos = (int)SvIV(ST(2));
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Audio::CD")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    cd_desc = INT2PTR(Audio__CD,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Audio::CD::play_pos",
			"cd_desc", "Audio::CD");

	RETVAL = cd_play_pos(cd_desc, track, startpos);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Audio__CD_track_advance); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__CD_track_advance)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 3 || items > 4)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Audio::CD::track_advance", "cd_desc, endtrack, minutes, seconds=0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Audio__CD	cd_desc;
	int	endtrack = (int)SvIV(ST(1));
	int	minutes = (int)SvIV(ST(2));
	int	seconds;
#line 218 "CD.xs"
    struct disc_timeval time;

#line 621 "CD.c"
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Audio::CD")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    cd_desc = INT2PTR(Audio__CD,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Audio::CD::track_advance",
			"cd_desc", "Audio::CD");

	if (items < 4)
	    seconds = 0;
	else {
	    seconds = (int)SvIV(ST(3));
	}
#line 221 "CD.xs"
    time.minutes = minutes;
    time.seconds = seconds;
    RETVAL = cd_track_advance(cd_desc, endtrack, time);

#line 644 "CD.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Audio__CD_advance); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__CD_advance)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Audio::CD::advance", "cd_desc, minutes, seconds=0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Audio__CD	cd_desc;
	int	minutes = (int)SvIV(ST(1));
	int	seconds;
#line 235 "CD.xs"
    struct disc_timeval time;

#line 669 "CD.c"
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Audio::CD")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    cd_desc = INT2PTR(Audio__CD,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Audio::CD::advance",
			"cd_desc", "Audio::CD");

	if (items < 3)
	    seconds = 0;
	else {
	    seconds = (int)SvIV(ST(2));
	}
#line 238 "CD.xs"
    time.minutes = minutes;
    time.seconds = seconds;
    RETVAL = cd_advance(cd_desc, time);

#line 692 "CD.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Audio__CD_get_volume); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__CD_get_volume)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Audio::CD::get_volume", "cd_desc");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Audio__CD	cd_desc;
	Audio__CD__Volume	RETVAL;

	if (sv_derived_from(ST(0), "Audio::CD")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    cd_desc = INT2PTR(Audio__CD,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Audio::CD::get_volume",
			"cd_desc", "Audio::CD");
#line 250 "CD.xs"
    RETVAL = (struct disc_volume *)safemalloc(sizeof(*RETVAL));
    cd_get_volume(cd_desc, RETVAL);

#line 726 "CD.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Audio::CD::Volume", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Audio__CD_set_volume); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__CD_set_volume)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Audio::CD::set_volume", "cd_desc, vol");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Audio__CD	cd_desc;
	Audio__CD__Volume	vol;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Audio::CD")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    cd_desc = INT2PTR(Audio__CD,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Audio::CD::set_volume",
			"cd_desc", "Audio::CD");

	if (sv_derived_from(ST(1), "Audio::CD::Volume")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    vol = INT2PTR(Audio__CD__Volume,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Audio::CD::set_volume",
			"vol", "Audio::CD::Volume");
#line 262 "CD.xs"
    RETVAL = cd_set_volume(cd_desc, *vol);

#line 771 "CD.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Audio__CD__Info_present); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__CD__Info_present)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Audio::CD::Info::present", "info");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Audio__CD__Info	info;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Audio::CD::Info")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    info = INT2PTR(Audio__CD__Info,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Audio::CD::Info::present",
			"info", "Audio::CD::Info");

	RETVAL = CD_Info_present(info);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Audio__CD__Info_mode); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__CD__Info_mode)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Audio::CD::Info::mode", "info");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Audio__CD__Info	info;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Audio::CD::Info")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    info = INT2PTR(Audio__CD__Info,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Audio::CD::Info::mode",
			"info", "Audio::CD::Info");

	RETVAL = CD_Info_mode(info);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Audio__CD__Info_current_track); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__CD__Info_current_track)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Audio::CD::Info::current_track", "info");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Audio__CD__Info	info;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Audio::CD::Info")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    info = INT2PTR(Audio__CD__Info,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Audio::CD::Info::current_track",
			"info", "Audio::CD::Info");

	RETVAL = CD_Info_current_track(info);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Audio__CD__Info_first_track); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__CD__Info_first_track)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Audio::CD::Info::first_track", "info");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Audio__CD__Info	info;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Audio::CD::Info")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    info = INT2PTR(Audio__CD__Info,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Audio::CD::Info::first_track",
			"info", "Audio::CD::Info");

	RETVAL = CD_Info_first_track(info);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Audio__CD__Info_total_tracks); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__CD__Info_total_tracks)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Audio::CD::Info::total_tracks", "info");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Audio__CD__Info	info;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Audio::CD::Info")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    info = INT2PTR(Audio__CD__Info,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Audio::CD::Info::total_tracks",
			"info", "Audio::CD::Info");

	RETVAL = CD_Info_total_tracks(info);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Audio__CD__Info_track_time); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__CD__Info_track_time)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Audio::CD::Info::track_time", "info");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Audio__CD__Info	info;

	if (sv_derived_from(ST(0), "Audio::CD::Info")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    info = INT2PTR(Audio__CD__Info,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Audio::CD::Info::track_time",
			"info", "Audio::CD::Info");

	CD_Info_track_time(info);
    }
    XSRETURN_EMPTY;
}


XS(XS_Audio__CD__Info_time); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__CD__Info_time)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Audio::CD::Info::time", "info");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Audio__CD__Info	info;

	if (sv_derived_from(ST(0), "Audio::CD::Info")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    info = INT2PTR(Audio__CD__Info,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Audio::CD::Info::time",
			"info", "Audio::CD::Info");

	CD_Info_time(info);
    }
    XSRETURN_EMPTY;
}


XS(XS_Audio__CD__Info_length); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__CD__Info_length)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Audio::CD::Info::length", "info");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Audio__CD__Info	info;

	if (sv_derived_from(ST(0), "Audio::CD::Info")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    info = INT2PTR(Audio__CD__Info,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Audio::CD::Info::length",
			"info", "Audio::CD::Info");

	CD_Info_length(info);
    }
    XSRETURN_EMPTY;
}


XS(XS_Audio__CD__Info_tracks); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__CD__Info_tracks)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Audio::CD::Info::tracks", "info");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Audio__CD__Info	info;
#line 306 "CD.xs"
   int track;

#line 1041 "CD.c"
	AV *	RETVAL;

	if (sv_derived_from(ST(0), "Audio::CD::Info")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    info = INT2PTR(Audio__CD__Info,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Audio::CD::Info::tracks",
			"info", "Audio::CD::Info");
#line 309 "CD.xs"
   RETVAL = newAV();
   for(track = 0; track < info->disc_total_tracks; track++) {
       av_push(RETVAL, CD_Info_track_new(&info->disc_track[track]));
   }

#line 1058 "CD.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Audio__CD__Info_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__CD__Info_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Audio::CD::Info::DESTROY", "info");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Audio__CD__Info	info;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    info = INT2PTR(Audio__CD__Info,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not a reference",
			"Audio::CD::Info::DESTROY",
			"info");
#line 322 "CD.xs"
   safefree(info);
#line 1090 "CD.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Audio__CD__Info__Track_length); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__CD__Info__Track_length)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Audio::CD::Info::Track::length", "tinfo");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Audio__CD__Info__Track	tinfo;

	if (sv_derived_from(ST(0), "Audio::CD::Info::Track")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    tinfo = INT2PTR(Audio__CD__Info__Track,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Audio::CD::Info::Track::length",
			"tinfo", "Audio::CD::Info::Track");

	CD_Info_Track_length(tinfo);
    }
    XSRETURN_EMPTY;
}


XS(XS_Audio__CD__Info__Track_pos); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__CD__Info__Track_pos)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Audio::CD::Info::Track::pos", "tinfo");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Audio__CD__Info__Track	tinfo;

	if (sv_derived_from(ST(0), "Audio::CD::Info::Track")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    tinfo = INT2PTR(Audio__CD__Info__Track,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Audio::CD::Info::Track::pos",
			"tinfo", "Audio::CD::Info::Track");

	CD_Info_Track_pos(tinfo);
    }
    XSRETURN_EMPTY;
}


XS(XS_Audio__CD__Info__Track_type); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__CD__Info__Track_type)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Audio::CD::Info::Track::type", "tinfo");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Audio__CD__Info__Track	tinfo;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Audio::CD::Info::Track")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    tinfo = INT2PTR(Audio__CD__Info__Track,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Audio::CD::Info::Track::type",
			"tinfo", "Audio::CD::Info::Track");

	RETVAL = CD_Info_Track_type(tinfo);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Audio__CD__Info__Track_is_audio); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__CD__Info__Track_is_audio)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Audio::CD::Info::Track::is_audio", "tinfo");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Audio__CD__Info__Track	tinfo;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Audio::CD::Info::Track")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    tinfo = INT2PTR(Audio__CD__Info__Track,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Audio::CD::Info::Track::is_audio",
			"tinfo", "Audio::CD::Info::Track");

	RETVAL = CD_Info_Track_is_audio(tinfo);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Audio__CD__Info__Track_is_data); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__CD__Info__Track_is_data)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Audio::CD::Info::Track::is_data", "tinfo");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Audio__CD__Info__Track	tinfo;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Audio::CD::Info::Track")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    tinfo = INT2PTR(Audio__CD__Info__Track,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Audio::CD::Info::Track::is_data",
			"tinfo", "Audio::CD::Info::Track");

	RETVAL = CD_Info_Track_is_data(tinfo);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Audio__CD__Data_title); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__CD__Data_title)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Audio::CD::Data::title", "data");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Audio__CD__Data	data;
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Audio::CD::Data")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    data = INT2PTR(Audio__CD__Data,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Audio::CD::Data::title",
			"data", "Audio::CD::Data");

	RETVAL = CD_Data_title(data);
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Audio__CD__Data_artist); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__CD__Data_artist)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Audio::CD::Data::artist", "data");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Audio__CD__Data	data;
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Audio::CD::Data")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    data = INT2PTR(Audio__CD__Data,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Audio::CD::Data::artist",
			"data", "Audio::CD::Data");

	RETVAL = CD_Data_artist(data);
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Audio__CD__Data_extended); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__CD__Data_extended)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Audio::CD::Data::extended", "data");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Audio__CD__Data	data;
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Audio::CD::Data")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    data = INT2PTR(Audio__CD__Data,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Audio::CD::Data::extended",
			"data", "Audio::CD::Data");

	RETVAL = CD_Data_extended(data);
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Audio__CD__Data_genre); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__CD__Data_genre)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Audio::CD::Data::genre", "data");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Audio__CD__Data	data;
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Audio::CD::Data")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    data = INT2PTR(Audio__CD__Data,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Audio::CD::Data::genre",
			"data", "Audio::CD::Data");

	RETVAL = CD_Data_genre(data);
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Audio__CD__Data_tracks); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__CD__Data_tracks)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Audio::CD::Data::tracks", "data, disc");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Audio__CD__Data	data;
	Audio__CD__Info	disc;
#line 371 "CD.xs"
   int track;

#line 1395 "CD.c"
	AV *	RETVAL;

	if (sv_derived_from(ST(0), "Audio::CD::Data")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    data = INT2PTR(Audio__CD__Data,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Audio::CD::Data::tracks",
			"data", "Audio::CD::Data");

	if (sv_derived_from(ST(1), "Audio::CD::Info")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    disc = INT2PTR(Audio__CD__Info,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Audio::CD::Data::tracks",
			"disc", "Audio::CD::Info");
#line 374 "CD.xs"
   RETVAL = newAV();
   for(track = 0; track < disc->disc_total_tracks; track++) {
       av_push(RETVAL, CD_Data_track_new(&data->data_track[track]));
   }

#line 1421 "CD.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Audio__CD__Data_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__CD__Data_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Audio::CD::Data::DESTROY", "data");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Audio__CD__Data	data;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    data = INT2PTR(Audio__CD__Data,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not a reference",
			"Audio::CD::Data::DESTROY",
			"data");
#line 387 "CD.xs"
   safefree(data);
#line 1453 "CD.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Audio__CD__Track_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__CD__Track_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Audio::CD::Track::name", "track");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Audio__CD__Track	track;
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Audio::CD::Track")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    track = INT2PTR(Audio__CD__Track,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Audio::CD::Track::name",
			"track", "Audio::CD::Track");

	RETVAL = CD_Track_name(track);
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Audio__CD__Track_artist); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__CD__Track_artist)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Audio::CD::Track::artist", "track");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Audio__CD__Track	track;
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Audio::CD::Track")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    track = INT2PTR(Audio__CD__Track,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Audio::CD::Track::artist",
			"track", "Audio::CD::Track");

	RETVAL = CD_Track_artist(track);
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Audio__CD__Track_extended); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__CD__Track_extended)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Audio::CD::Track::extended", "track");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Audio__CD__Track	track;
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Audio::CD::Track")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    track = INT2PTR(Audio__CD__Track,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Audio::CD::Track::extended",
			"track", "Audio::CD::Track");

	RETVAL = CD_Track_extended(track);
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Audio__CDDB_verbose); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__CDDB_verbose)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Audio::CDDB::verbose", "sv, flag");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SV *	sv = ST(0);
	int	flag = (int)SvIV(ST(1));

	cddb_verbose(sv, flag);
    }
    XSRETURN_EMPTY;
}


XS(XS_Audio__CDDB_discid); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__CDDB_discid)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Audio::CDDB::discid", "h");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Audio__CDDB	h;
	unsigned long	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Audio::CDDB")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    h = INT2PTR(Audio__CDDB,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Audio::CDDB::discid",
			"h", "Audio::CDDB");

	RETVAL = cddb_discid(h);
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Audio__CDDB_lookup); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__CDDB_lookup)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Audio::CDDB::lookup", "cd_desc");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Audio__CDDB	cd_desc;
	Audio__CD__Data	RETVAL;

	if (sv_derived_from(ST(0), "Audio::CDDB")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    cd_desc = INT2PTR(Audio__CDDB,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Audio::CDDB::lookup",
			"cd_desc", "Audio::CDDB");
#line 421 "CD.xs"
    RETVAL = (Audio__CD__Data)safemalloc(sizeof(*RETVAL));
    cddb_lookup(cd_desc, RETVAL);

#line 1635 "CD.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Audio::CD::Data", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Audio__CD__Volume_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__CD__Volume_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Audio::CD::Volume::DESTROY", "vol");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Audio__CD__Volume	vol;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    vol = INT2PTR(Audio__CD__Volume,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not a reference",
			"Audio::CD::Volume::DESTROY",
			"vol");
#line 434 "CD.xs"
   safefree(vol);
#line 1667 "CD.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Audio__CD__Volume_front); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__CD__Volume_front)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Audio::CD::Volume::front", "vol");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Audio__CD__Volume	vol;
	Audio__CD__VolumeRL	RETVAL;

	if (sv_derived_from(ST(0), "Audio::CD::Volume")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    vol = INT2PTR(Audio__CD__Volume,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Audio::CD::Volume::front",
			"vol", "Audio::CD::Volume");

	RETVAL = CD_Volume_front(vol);
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Audio::CD::VolumeRL", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Audio__CD__Volume_back); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__CD__Volume_back)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Audio::CD::Volume::back", "vol");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Audio__CD__Volume	vol;
	Audio__CD__VolumeRL	RETVAL;

	if (sv_derived_from(ST(0), "Audio::CD::Volume")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    vol = INT2PTR(Audio__CD__Volume,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Audio::CD::Volume::back",
			"vol", "Audio::CD::Volume");

	RETVAL = CD_Volume_back(vol);
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Audio::CD::VolumeRL", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Audio__CD__VolumeRL_left); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__CD__VolumeRL_left)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Audio::CD::VolumeRL::left", "volrl, val=-1");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Audio__CD__VolumeRL	volrl;
	int	val;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Audio::CD::VolumeRL")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    volrl = INT2PTR(Audio__CD__VolumeRL,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Audio::CD::VolumeRL::left",
			"volrl", "Audio::CD::VolumeRL");

	if (items < 2)
	    val = -1;
	else {
	    val = (int)SvIV(ST(1));
	}

	RETVAL = CD_VolumeRL_left(volrl, val);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Audio__CD__VolumeRL_right); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__CD__VolumeRL_right)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Audio::CD::VolumeRL::right", "volrl, val=-1");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Audio__CD__VolumeRL	volrl;
	int	val;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Audio::CD::VolumeRL")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    volrl = INT2PTR(Audio__CD__VolumeRL,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Audio::CD::VolumeRL::right",
			"volrl", "Audio::CD::VolumeRL");

	if (items < 2)
	    val = -1;
	else {
	    val = (int)SvIV(ST(1));
	}

	RETVAL = CD_VolumeRL_right(volrl, val);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_Audio__CD); /* prototype to pass -Wmissing-prototypes */
XS(boot_Audio__CD)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    char* file = __FILE__;

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    XS_VERSION_BOOTCHECK ;

        newXS("Audio::CD::init", XS_Audio__CD_init, file);
        newXS("Audio::CD::DESTROY", XS_Audio__CD_DESTROY, file);
        newXS("Audio::CD::cddb", XS_Audio__CD_cddb, file);
        newXS("Audio::CD::play", XS_Audio__CD_play, file);
        newXS("Audio::CD::stop", XS_Audio__CD_stop, file);
        newXS("Audio::CD::pause", XS_Audio__CD_pause, file);
        newXS("Audio::CD::resume", XS_Audio__CD_resume, file);
        newXS("Audio::CD::eject", XS_Audio__CD_eject, file);
        newXS("Audio::CD::close", XS_Audio__CD_close, file);
        newXS("Audio::CD::stat", XS_Audio__CD_stat, file);
        newXS("Audio::CD::play_frames", XS_Audio__CD_play_frames, file);
        newXS("Audio::CD::play_track_pos", XS_Audio__CD_play_track_pos, file);
        newXS("Audio::CD::play_track", XS_Audio__CD_play_track, file);
        newXS("Audio::CD::play_pos", XS_Audio__CD_play_pos, file);
        newXS("Audio::CD::track_advance", XS_Audio__CD_track_advance, file);
        newXS("Audio::CD::advance", XS_Audio__CD_advance, file);
        newXS("Audio::CD::get_volume", XS_Audio__CD_get_volume, file);
        newXS("Audio::CD::set_volume", XS_Audio__CD_set_volume, file);
        newXS("Audio::CD::Info::present", XS_Audio__CD__Info_present, file);
        newXS("Audio::CD::Info::mode", XS_Audio__CD__Info_mode, file);
        newXS("Audio::CD::Info::current_track", XS_Audio__CD__Info_current_track, file);
        newXS("Audio::CD::Info::first_track", XS_Audio__CD__Info_first_track, file);
        newXS("Audio::CD::Info::total_tracks", XS_Audio__CD__Info_total_tracks, file);
        newXS("Audio::CD::Info::track_time", XS_Audio__CD__Info_track_time, file);
        newXS("Audio::CD::Info::time", XS_Audio__CD__Info_time, file);
        newXS("Audio::CD::Info::length", XS_Audio__CD__Info_length, file);
        newXS("Audio::CD::Info::tracks", XS_Audio__CD__Info_tracks, file);
        newXS("Audio::CD::Info::DESTROY", XS_Audio__CD__Info_DESTROY, file);
        newXS("Audio::CD::Info::Track::length", XS_Audio__CD__Info__Track_length, file);
        newXS("Audio::CD::Info::Track::pos", XS_Audio__CD__Info__Track_pos, file);
        newXS("Audio::CD::Info::Track::type", XS_Audio__CD__Info__Track_type, file);
        newXS("Audio::CD::Info::Track::is_audio", XS_Audio__CD__Info__Track_is_audio, file);
        newXS("Audio::CD::Info::Track::is_data", XS_Audio__CD__Info__Track_is_data, file);
        newXS("Audio::CD::Data::title", XS_Audio__CD__Data_title, file);
        newXS("Audio::CD::Data::artist", XS_Audio__CD__Data_artist, file);
        newXS("Audio::CD::Data::extended", XS_Audio__CD__Data_extended, file);
        newXS("Audio::CD::Data::genre", XS_Audio__CD__Data_genre, file);
        newXS("Audio::CD::Data::tracks", XS_Audio__CD__Data_tracks, file);
        newXS("Audio::CD::Data::DESTROY", XS_Audio__CD__Data_DESTROY, file);
        newXS("Audio::CD::Track::name", XS_Audio__CD__Track_name, file);
        newXS("Audio::CD::Track::artist", XS_Audio__CD__Track_artist, file);
        newXS("Audio::CD::Track::extended", XS_Audio__CD__Track_extended, file);
        newXS("Audio::CDDB::verbose", XS_Audio__CDDB_verbose, file);
        newXS("Audio::CDDB::discid", XS_Audio__CDDB_discid, file);
        newXS("Audio::CDDB::lookup", XS_Audio__CDDB_lookup, file);
        newXS("Audio::CD::Volume::DESTROY", XS_Audio__CD__Volume_DESTROY, file);
        newXS("Audio::CD::Volume::front", XS_Audio__CD__Volume_front, file);
        newXS("Audio::CD::Volume::back", XS_Audio__CD__Volume_back, file);
        newXS("Audio::CD::VolumeRL::left", XS_Audio__CD__VolumeRL_left, file);
        newXS("Audio::CD::VolumeRL::right", XS_Audio__CD__VolumeRL_right, file);

    /* Initialisation Section */

#line 124 "CD.xs"
    boot_Audio__CD_constants();
    cddb_inexact_selection_set(inexact_select_func);

#line 1888 "CD.c"

    /* End of Initialisation Section */

    if (PL_unitcheckav)
         call_list(PL_scopestack_ix, PL_unitcheckav);
    XSRETURN_YES;
}

